import java.io.RandomAccessFile;
import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.text.DecimalFormat;

public class BlockDB {
    String prefix;
    DecimalFormat formatter;
    
    public BlockDB(String prefix) {
	this.prefix = prefix;
	formatter = new DecimalFormat("00000");
    }

    public RandomAccessFile openFile(int fileNr) throws FileNotFoundException{
	String fileName = prefix + formatter.format(fileNr) + ".dat";
	return new RandomAccessFile(fileName, "r");
    }

    public Transaction readTransaction(int fileNr, int txOffset) {
	try {
	    RandomAccessFile file = openFile(fileNr);
	    file.seek(txOffset);
	    //System.err.println("Reading TX: " + fileNr + " / " + txOffset);
	    Transaction tx = new Transaction();
	    tx.read(new BlockInputStream(new BufferedInputStream(new FileInputStream(file.getFD()))));
	    file.close();
	    return tx;
	} catch (IOException ex) {
	    throw new RuntimeException("", ex);
	}
    }
}